#include "H.H"
/*   MICHAEL J. CHAPPELL      September 17, 1994       ADDRBOOK.CU

          THIS PROGRAM WILL UTILIZE A DATABASE FOR ADDRESSES.
*/

#include "ADDRBOOK.H"

RECORD_T  RECORD[MAXRECORDS];
MF_T      MF;
INT       CHANGES;

INT  COMPARE_LAST_NAMES(RECORD_T *A, RECORD_T *B) {
     INT TEMP;

     IF (TEMP = STRCMP(A->NAME.LAST, B->NAME.LAST))
          RETURN TEMP;
     IF (TEMP = STRCMP(A->NAME.FIRST, B->NAME.FIRST))
          RETURN TEMP;
     RETURN STRCMP(A->NAME.MIDDLE, B->NAME.MIDDLE);
} /* COMPARE_LAST_NAMES */

INT  COMPARE_FIRST_NAMES(RECORD_T *A, RECORD_T *B) {
     INT TEMP;

     IF (TEMP = STRCMP(A->NAME.FIRST, B->NAME.FIRST))
          RETURN TEMP;
     IF (TEMP = STRCMP(A->NAME.MIDDLE, B->NAME.MIDDLE))
          RETURN TEMP;
     RETURN STRCMP(A->NAME.LAST, B->NAME.LAST);
} /* COMPARE_FIRST_NAMES */

INT  COMPARE_PHONE_NUMBERS(RECORD_T *A, RECORD_T *B) {
     INT  I, J;
     CHAR NO_A[20], NO_B[20];

     FOR (I=0, J=0; A->PHONE[I]; I++)
          IF (ISALNUM(A->PHONE[I]))
               NO_A[J++] = A->PHONE[I];
     NO_A[J] = '\0';
     FOR (I=0, J=0; B->PHONE[I]; I++)
          IF (ISALNUM(B->PHONE[I]))
               NO_B[J++] = B->PHONE[I];
     NO_B[J] = '\0';
     RETURN STRCMP(NO_A, NO_B);
} /* COMPARE_PHONE_NUMBERS */

VOID SORT(INT N, INT (*F1)()) {
     IF (N<2) RETURN;
     QSORT(RECORD, N, SIZEOF(RECORD[0]), F1);
} /* SORT */

INT  INITIALIZE(VOID) {
     RETURN LOAD_RECORDS();
} /* INITIALIZE */

INT  MENU1(INT NUM_REC) {
     SIGNED CHAR COUNT;
     MAIN_T N;
     INT NUM_SEL, CUR_REC=0;
     COUNT = NUM_REC;
     CUR_REC = COUNT;
     NUM_SEL = SELECT_RECORDS(COUNT, 1);
     DO {
          INITIALIZE_MENU();
          N = CENTER_MENU(16, MENU1_TXT, 3);
          SWITCH (N) {
               CASE ABOUT:  
               CASE ABOUT2:   
                        ADDRESS_INFO();
                        BREAK;
               CASE ADD:   
                        COUNT   = ADD_RECORD(COUNT);
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        CHANGES = TRUE;
                        SORT(COUNT, COMPARE_LAST_NAMES);
                        BREAK;
               CASE COPY:   
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        COUNT = COPY_RECORD(COUNT, NUM_SEL);
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        CHANGES = TRUE;
                        SORT(COUNT, COMPARE_LAST_NAMES);
                        BREAK;
               CASE DISPLAYSEL:   
                        DISPLAY_SELECT(COUNT, NUM_SEL);
                        BREAK;
               CASE EDIT:   
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        EDIT_RECORD(COUNT, NUM_SEL);
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        CHANGES = TRUE;
                        SORT(COUNT, COMPARE_LAST_NAMES);
                        BREAK;
               CASE PSEL:   
                        PRINT_SELECT(COUNT, NUM_SEL);
                        BREAK;
               CASE RREMOVE:   
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        COUNT = REMOVE_RECORD(COUNT, NUM_SEL);
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        CHANGES = TRUE;
                        SORT(COUNT, COMPARE_LAST_NAMES);
                        BREAK;
               CASE SAVE:   
                        SAVE_RECORDS(COUNT);
                        CHANGES = FALSE;
                        BREAK;
               CASE SELECT:   
                        NUM_SEL = SELECT_RECORDS(COUNT, 0);
                        BREAK;
               CASE UNDO:  
                        COUNT = LOAD_RECORDS();
                        NUM_SEL = SELECT_RECORDS(COUNT, 1);
                        CHANGES = FALSE;
                        BREAK;
               CASE DISPLAYINDEX:  
                        SHOW_LIST_OF_NAMES(COUNT);
                        BREAK;
               CASE DISPLAYNUM:  
                        DISPLAY_RECORD_NUMBER(COUNT);
                        BREAK;
               CASE PINDEX:  
                        PRINT_LIST_OF_NAMES(COUNT);
                        BREAK;
               case HELP:
                        show_file("addrbook.hlp");
                        break;
               case PHELP:  
                        print_file("addrbook.hlp");
                        break;
               CASE EXPORT:   
                        EXPORT_SELECT(COUNT, NUM_SEL);
                        BREAK;
               CASE RQUIT:  
                        EXIT_ADDRESS(COUNT);
                        BREAK;
          } /* SWITCH */
     } WHILE (N<16);
     RETURN COUNT;
} /* MENU1 */

VOID ADDRESS_INFO(VOID) {
          CLS();
          BOX(10, 26, 15, 54, 0X70, 1);
          poscurs(10, 27);
          printf("   Address Book Database");
          poscurs(11, 27);
          printf("  By: Michael J. Chappell");
          poscurs(12, 27);
          printf("September 1994 - August 1999");
          poscurs(13, 27);
          printf("Distributed by:  JUDGEWARE");
          HIT_ANY_KEY();
} /* ADDRESS_INFO */

INT  ADD_RECORD(INT N) {
     CHAR C[10];

     IF (N == MAXRECORDS) RETURN N; 
     CLS();
     RECORD[N].MF.MASK = 0; /* INITIALIZE MASK TO ZERO */
     RECORD[N].MF.FLAG.USED = TRUE;
     PRINTF("\nENTER FIRST NAME.       >  ");     
     INPUT(RECORD[N].NAME.FIRST, ALPHA, 15); 
     PRINTF("ENTER MIDDLE NAME.      >  ");
     INPUT(RECORD[N].NAME.MIDDLE, ALPHA, 10);
     PRINTF("ENTER LAST NAME.        >  ");
     INPUT(RECORD[N].NAME.LAST, ALPHA, 25);
     PRINTF("\nENTER STREET ADDRESS.   >  ");
     INPUT(RECORD[N].ADDRESS.STREET, ALPHANUMERIC, 40);
     PRINTF("ENTER CITY.             >  ");
     INPUT(RECORD[N].ADDRESS.CITY, ALPHA, 25);
     PRINTF("ENTER STATE.            >  ");
     INPUT(RECORD[N].ADDRESS.STATE, ALPHA, 4);
     PRINTF("ENTER ZIP CODE.         >  ");
     INPUT(RECORD[N].ADDRESS.ZIP, ALPHANUMERIC, 11);
     PRINTF("ENTER TELEPHONE NUMBER. >  ");
     INPUT(RECORD[N].PHONE, ALPHANUMERIC, 20);
     PRINTF("DO YOU KNOW THE DATE OF BIRTH ?  "); 
     INPUT(C, "YN", 2);
     IF (C[0] == 'N')
          RECORD[N].MF.FLAG.DOBKNOWN = FALSE;
     ELSE {
          RECORD[N].MF.FLAG.DOBKNOWN = TRUE;
          PRINTF("ENTER DATE OF BIRTH. (MM/DD/YY) >  ");
          GET_DATE(& RECORD[N].DOB);
     }
     RETURN (N+1);
} /* ADD_RECORD */

INT  COPY_RECORD(INT N, NUM_SEL) { 
     INT D, X;
     CHAR C[2];
     char TEMP[80];

     CLS();
     IF (N == 0)
          RETURN 0;
     IF (N == MAXRECORDS)
          RETURN N;
     PRINTF("\nENTER THE RECORD NUMBER TO BE COPIED. 1..%d >  ", NUM_SEL);
     INPUT(TEMP, "0123456789", 4);
     X = ATOI(TEMP);
     IF ((X>N)||(X==0)) {
          CLS();
          BOX(8, 20, 16, 60, 0X70, 1);
          POSCURS(11, 21);
          PRINTF("RECORD IS OUT OF RANGE\n\a");
          HIT_ANY_KEY();
          RETURN N;
     }
     D = X-1;
     PRINTF("\n\n");
     IF (! RECORD[D].MF.FLAG.USED || RECORD[D].MF.FLAG.DELETED)
          RETURN N;
     IF ((D<0)||(D>NUM_SEL))
          RETURN N;
     DISPLAY_RECORD(D, NUM_SEL, D+1);
     PRINTF("\n\nARE YOU SURE YOU WANT THIS RECORD COPIED ?  ");
     INPUT(C, "YN", 2);
     IF (C[0] == 'N') RETURN N;
     MEMCPY(&RECORD[N], &RECORD[D], SIZEOF(RECORD[0]));
     RETURN (N+1);
} /* COPY_RECORD */

VOID DISPLAY_RECORD(INT X, INT N, INT C) {
     POSCURS(4, 17);
     IF (N==-1) {
          PRINTF("RECORD:        %d\n", X+1);
     } ELSE {
          PRINTF("RECORD:        %d OF %d\t\t\t%d\n", C, N, X+1);
     }
     POSCURS(6, 17);
     PRINTF("NAME:          %s %s %s\n", RECORD[X].NAME.FIRST,
          RECORD[X].NAME.MIDDLE, RECORD[X].NAME.LAST);
     POSCURS(8, 17);
     PRINTF("ADDRESS:       %s\n", RECORD[X].ADDRESS.STREET);
     POSCURS(9, 17);
     IF (RECORD[X].ADDRESS.CITY[0])
          PRINTF("               %s, %s  %s\n", RECORD[X].ADDRESS.CITY,
               RECORD[X].ADDRESS.STATE, RECORD[X].ADDRESS.ZIP);
     POSCURS(11, 17);
     PRINTF("PHONE NUMBER:  %s\n", RECORD[X].PHONE);
     POSCURS(13, 17);
     PRINTF("DATE OF BIRTH: ");
     IF (RECORD[X].MF.FLAG.DOBKNOWN)
          DISPLAY_DATE(RECORD[X].DOB);
     POSCURS(14, 17);
} /* DISPLAY_RECORD */

VOID DISPLAY_SELECT(INT N, INT NUM_SELECTED) {
     INT I, C, t;
     
     IF (NUM_SELECTED<1) {
          CLS();
          BOX(8, 20, 16, 60, 0X70, 1);
          POSCURS(11, 21);
          PRINTF("NO RECORDS ARE SELECTED, OR NONE PRESENT\n\a");
          HIT_ANY_KEY();
          RETURN;
     } /* IF  (PREVENTS SCREEN FROM FLASHING IF NO RECORDS ARE AVAILABLE) */
     FOR (I=0, C = 1; I<N;)
          IF (SELECTED(I)) {
               CLS();
               BOX(6, 16, 16, 62, 0X70, 3);
               DISPLAY_RECORD(I, NUM_SELECTED, C);
               IF ((t = HIT_ANY_KEY())==1) BREAK;
               switch (t) {
                    case 0:     /* Advance */
                        I++;
                        C++;
                        break;
                    case 2:     /* Home */
                        I=0;
                        C=1;
                        break;
                    case 3:     /* Back up: PgUp, Left, Up */
                        if ((C<=1)||(I<=0))
                            break;
                        for (I--;!SELECTED(I);I--) ;
                        C--;
                        break;
                    case 4:     /* End: goto last record */
                        C=NUM_SELECTED;
                        I=N;
                        for (;!SELECTED(I);I--) ;
                        break;
               } /* switch */
          } else I++;
} /* DISPLAY_SELECT */

VOID DISPLAY_RECORD_NUMBER(INT N) {
     CHAR TEMP[80];
     INT  X;

     IF (N<1) {
          CLS();
          BOX(8, 20, 16, 60, 0X70, 1);
          POSCURS(11, 21);
          PRINTF("NO RECORDS ARE SELECTED, OR NONE PRESENT\n\a");
          HIT_ANY_KEY();
          RETURN;
     } /* IF  (PREVENTS SCREEN FROM FLASHING IF NO RECORDS ARE AVAILABLE) */
     PRINTF("\nENTER THE RECORD NUMBER TO DISPLAY. >  ");
     INPUT(TEMP, "0123456789", 4);
     X = ATOI(TEMP);
     IF ((X>N)||(X==0)) {
          CLS();
          BOX(8, 20, 16, 60, 0X70, 1);
          POSCURS(11, 21);
          PRINTF("RECORD IS OUT OF RANGE\n\a");
          HIT_ANY_KEY();
          RETURN;
     }
     CLS();
     BOX(6, 16, 16, 62, 0X70, 3);
     DISPLAY_RECORD(X-1, -1, 0);
     HIT_ANY_KEY();
} /* DISPLAY_RECORD_NUMBER */

INT  EDIT_STRING( CHAR * STRNG, CHAR * ALLOWED, INT N ) {
     INT  OLD_CUR,
          OLD_LEN,
          BUF_CUR,
          R, C;
     INT  DONE = 0;
     CHAR BUF[80];
     CHAR CH;

     R = CURSROW();
     C = CURSCOL();
     IF (R<2)                           /* TOP 2 ROWS */
          RETURN 0;                     /* NOT ENOUGH ROOM FOR OLD */
     IF (C+N >78)                       /* MAXLENGTH WILL EXCEED WIDTH */
          RETURN 0;                     /* EXIT ERROR */
     POSCURS(R-2, C);                   /* PUT OLD STRING UP TWO LINES */
     PRINTF(STRNG);

     OLD_CUR = 0;
     BUF_CUR = 0;
     OLD_LEN = STRLEN(STRNG);
     WHILE ((BUF_CUR<N)&&!DONE) {       /* WHILE NEW STRING < MAXLEN */
          IF (OLD_CUR<OLD_LEN) {        /* IF PTR STILL IN STRING */
               POSCURS(R-1, C+OLD_CUR); /* POINT TO CURRENT CHAR WITH */
               PUTCHAR('^');            /* A ^ */
          } /* IF */
          POSCURS(R, C+BUF_CUR);
          CH = GETCH();
          CH = TOUPPER(CH);
          SWITCH (CH) {            
               CASE '\0':          /* EXTENDED */
                    EXTENDED(R,C,OLD_LEN,N,STRNG,BUF,&OLD_CUR,&BUF_CUR);
                    BREAK;
               CASE '\b':          /* BACKSPACE */
                    IF (BUF_CUR == 0) {
                         PUTCHAR('\a');
                         BREAK;
                    }
                    PUTCHAR('\b');
                    PUTCHAR(' ');
                    PUTCHAR('\b');
                    BUF_CUR--;
                    BREAK;
               CASE '\r':          /* CARRIAGE RETURN */
                    DONE = 1;
                    BREAK;
               CASE 27:            /* ESCAPE */
                    POSCURS(R-1, C+OLD_CUR);
                    PUTCHAR(' ');
                    POSCURS(R, C+BUF_CUR);
                    FOR (; BUF_CUR; BUF_CUR--) {
                         PUTCHAR('\b');
                         PUTCHAR(' ');
                         PUTCHAR('\b');
                    }
                    BUF_CUR = 0;
                    OLD_CUR = 0;
                    BREAK;
               DEFAULT:
                    IF (ACCEPTED(CH, ALLOWED)) {
                         POSCURS(R, C+BUF_CUR);
                         PUTCHAR(CH);
                         BUF[BUF_CUR++] = CH;
                    } ELSE
                         PUTCHAR('\a');
                    BREAK;
          } /* SWITCH */
     } /* WHILE */         
     BUF[BUF_CUR] = '\0';          /* DELIMIT END OF STRING */
     IF (BUF[0]) {                 /* IF NEW STRING WAS ENTERED THEN */
          STRCPY(STRNG, BUF);      /* COPY IT AND RETURN THE LENGTH */
          RETURN STRLEN(STRNG);
     } ELSE                        /* ELSE RETURN THE LENGTH OF THE */
          RETURN STRLEN(STRNG);    /* LENGTH OF THE ORIGINAL STRING */
} /* EDIT_STRING */

VOID EXTENDED(INT R, C, O_L, B_L, CHAR *STRNG, CHAR *BUF, INT *OC, INT *BC) {                    
     CHAR CHX;
     INT OLD_CUR, BUF_CUR;
     INT I, J;

     OLD_CUR = *OC;
     BUF_CUR = *BC;
     CHX = GETCH();
     SWITCH (CHX) {
          CASE 59:  /* F1 */
               IF (OLD_CUR>=O_L) {
                    PUTCHAR('\a');
                    BREAK;
               }
               POSCURS(R-1,C+OLD_CUR);
               PUTCHAR(' ');
               POSCURS(R,C+BUF_CUR);
               PUTCHAR(STRNG[OLD_CUR]);
               BUF[BUF_CUR++] = STRNG[OLD_CUR++];
               BREAK;
          CASE 61:  /* F3 */
               IF ((BUF_CUR+O_L-OLD_CUR)>B_L) {
                    PUTCHAR('\a'); /* BEEP */
                    BREAK;
               }
               POSCURS(R-1, C+OLD_CUR);
               PUTCHAR(' ');
               FOR (; STRNG[OLD_CUR]; OLD_CUR++, BUF_CUR++) {
                    BUF[BUF_CUR] = STRNG[OLD_CUR];
                    POSCURS(R, C+BUF_CUR);
                    PUTCHAR(BUF[BUF_CUR]);
               } /* FOR */
               BREAK;
          CASE 75:  /* LEFT ARROW */
               IF (OLD_CUR<1) {
                    PUTCHAR('\a'); /* BEEP */
                    BREAK;
               }
               POSCURS(R-1, C+OLD_CUR);
               PUTCHAR(' ');
               OLD_CUR--;
               BREAK;
          CASE 83:  /* DELETE */
          CASE 77:  /* RIGHT ARROW */
               IF (OLD_CUR>=O_L) {
                    PUTCHAR('\a'); /* BEEP */
                    BREAK;
               }
               POSCURS(R-1, C+OLD_CUR);
               PUTCHAR(' ');
               OLD_CUR++;
               BREAK;
          CASE 71:  /* HOME */
               POSCURS(R-1, C+OLD_CUR);
               PUTCHAR(' ');
               OLD_CUR = 0;
               BREAK;
          CASE 79:  /* END */
               POSCURS(R-1, C+OLD_CUR);
               PUTCHAR(' ');
               OLD_CUR = O_L-1;
               BREAK;
          DEFAULT:  /* ILLEGAL CHARACTER */
               PUTCHAR('\a'); /* BEEP */
               BREAK;
     } /* SWITCH EXTENDED */
     *OC = OLD_CUR;
     *BC = BUF_CUR;
     RETURN;
} /* EXTENDED */

VOID EDIT_RECORD(INT N, NUM_SEL) {
     INT D, X, SEL;
     CHAR C[2], TEMP[80];

     CLS();
     IF (NUM_SEL == 0) RETURN;
     PRINTF("\nENTER THE RECORD NUMBER TO BE EDITED. 1..%d >  ", NUM_SEL);
     INPUT(TEMP, "0123456789", 4);
     X = ATOI(TEMP);
     IF ((X>N)||(X==0)) {
          CLS();
          BOX(8, 20, 16, 60, 0X70, 1);
          POSCURS(11, 21);
          PRINTF("RECORD IS OUT OF RANGE\n\a");
          HIT_ANY_KEY();
          RETURN;
     }
     D = X-1;
     PRINTF("\n\n");
     DISPLAY_RECORD(D, NUM_SEL, D+1);
     PRINTF("\n\nARE YOU SURE THIS IS THE RECORD YOU WANT TO EDIT ?  ");
     INPUT(C, "YN", 2);
     IF (C[0] != 'Y') RETURN N;
     INITIALIZE_MENU();
     DO {
          SEL = CENTER_MENU(10, MENU2_TXT, 3);
          SWITCH (SEL) {
               CASE 1:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD FIRST NAME:");
                    PRINTF("\n\nNEW FIRST NAME:  ");
                    EDIT_STRING(RECORD[D].NAME.FIRST, ALPHA, 15);
                    BREAK;
               CASE 2:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD MIDDLE NAME:");
                    PRINTF("\n\nNEW MIDDLE NAME:  ");
                    EDIT_STRING(RECORD[D].NAME.MIDDLE, ALPHA, 10);
                    BREAK;
               CASE 3:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD LAST NAME:");
                    PRINTF("\n\nNEW LAST NAME:  ");
                    EDIT_STRING(RECORD[D].NAME.LAST, ALPHA, 25);
                    BREAK;
               CASE 4:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD STREET ADDRESS:");
                    PRINTF("\n\nNEW STREET ADDRESS:  ");
                    EDIT_STRING(RECORD[D].ADDRESS.STREET, ALPHANUMERIC, 40);
                    BREAK;
               CASE 5:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD CITY:");
                    PRINTF("\n\nNEW CITY:  ");
                    EDIT_STRING(RECORD[D].ADDRESS.CITY, ALPHA, 25);
                    BREAK;
               CASE 6:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD STATE ABBREVIATION:");
                    PRINTF("\n\nNEW STATE ABBREVIATION:  ");
                    EDIT_STRING(RECORD[D].ADDRESS.STATE, ALPHA, 4);
                    BREAK;
               CASE 7:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD ZIP CODE:");
                    PRINTF("\n\nNEW ZIP CODE:  ");
                    EDIT_STRING(RECORD[D].ADDRESS.ZIP, ALPHANUMERIC, 11);
                    BREAK;
               CASE 8:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nOLD PHONE NUMBER:");
                    PRINTF("\n\nNEW PHONE NUMBER:  ");
                    EDIT_STRING(RECORD[D].PHONE, ALPHANUMERIC, 15);
                    BREAK;
               CASE 9:
                    DISPLAY_RECORD(D, NUM_SEL, D+1);
                    PRINTF("\n\nDO YOU KNOW THE DATE OF BIRTH ?  ");
                    INPUT(C, "YN", 2);
                    IF (C[0] == 'N') {
                         RECORD[D].MF.FLAG.DOBKNOWN = FALSE;
                    } ELSE {
                         RECORD[D].MF.FLAG.DOBKNOWN = TRUE;
                         PRINTF("\n\nENTER DATE OF BIRTH. >  ");
                         GET_DATE(& RECORD[D].DOB);
                    }
                    BREAK;
               DEFAULT:
                    SEL = 0;
                    BREAK;
          } /* SWITCH SEL */
     } WHILE (SEL > 0);
} /* EDIT_RECORD */

INT  REMOVE_RECORD(INT N, NUM_SEL) {
     INT D, X;
     CHAR C[2], TEMP[80];

     CLS();
     IF (N == 0) RETURN N;
     PRINTF("\nENTER THE RECORD NUMBER TO BE DELETED. 1..%d >  ", NUM_SEL);
     INPUT(TEMP, "0123456789", 4);
     X = ATOI(TEMP);
     IF ((X>N)||(X==0)) {
          CLS();
          BOX(8, 20, 16, 60, 0X70, 1);
          POSCURS(11, 21);
          PRINTF("RECORD IS OUT OF RANGE\n\a");
          HIT_ANY_KEY();
          RETURN;
     }
     D = X-1;
     PRINTF("\n\n");
     IF ((RECORD[D].MF.FLAG.USED == 0)||(RECORD[D].MF.FLAG.DELETED))
          RETURN N;
     DISPLAY_RECORD(D, NUM_SEL, D+1);
     PRINTF("\n\nARE YOU SURE YOU WANT THIS RECORD DELETED ?  ");
     INPUT(C, "YN", 2);
     IF (C[0] != 'Y') RETURN N;
     RECORD[D].MF.FLAG.DOBKNOWN = FALSE;
     RECORD[D].MF.FLAG.USED     = FALSE;
     RECORD[D].MF.FLAG.SELECTED = FALSE;
     RECORD[D].MF.FLAG.DELETED  = TRUE;
     IF (D<(N-1))
          MEMCPY(&RECORD[D], &RECORD[N-1], SIZEOF(RECORD[0]));
     RETURN (N-1);
} /* REMOVE_RECORD */

VOID PRINT_RECORD(INT X, INT N, INT C) {
     IF (N==-1)
          FPRINTF(LP, "\nRECORD:       %d", X+1);
     ELSE 
          FPRINTF(LP, "\nRECORD:       %d OF %d\t\t\t%d", C, N, X+1);
     FPRINTF(LP, "\nNAME:         %s %s %s", RECORD[X].NAME.FIRST,
          RECORD[X].NAME.MIDDLE, RECORD[X].NAME.LAST);
     FPRINTF(LP, "\nADDRESS:      %s", RECORD[X].ADDRESS.STREET);
     FPRINTF(LP, "\n              %s, %s  %s", RECORD[X].ADDRESS.CITY,
          RECORD[X].ADDRESS.STATE, RECORD[X].ADDRESS.ZIP);
     FPRINTF(LP, "\nPHONE NUMBER: %s", RECORD[X].PHONE);
     FPRINTF(LP, "\nDATE OF BIRTH:  ");
     IF (RECORD[X].MF.FLAG.DOBKNOWN)
          PRINT_DATE(RECORD[X].DOB);
} /* PRINT_RECORD */

VOID PRINT_SELECT(INT N, INT NUM_SELECTED) {
     INT I, C;
     
     FOR (I=0, C = 1; I<N; I++)
          IF (SELECTED(I)) {
               PRINT_RECORD(I, NUM_SELECTED, C++);
               FPRINTF(LP, "\n\n");
          }
     HIT_ANY_KEY();
} /* PRINT_SELECT */

VOID EXPORT_RECORD(INT X, INT N, INT C, FILE *TXTP) {
     FPRINTF(TXTP, "\n%s, %s %s", RECORD[X].NAME.LAST,
          RECORD[X].NAME.FIRST, RECORD[X].NAME.MIDDLE);   /* name */
     FPRINTF(TXTP, "\t%s", RECORD[X].PHONE);              /* home phone assumed */
     FPRINTF(TXTP, "\t");                                 /* beeper */
     FPRINTF(TXTP, "\t");                                 /* cellular */
     FPRINTF(TXTP, "\t");                                 /* work */
     FPRINTF(TXTP, "\t%d", X+1);                          /* notes */
     FPRINTF(TXTP, "\t");
     IF (RECORD[X].MF.FLAG.DOBKNOWN)
          FPRINT_DATE(TXTP, RECORD[X].DOB);               /* date of birth */ 
     FPRINTF(TXTP, "\t%s", RECORD[X].ADDRESS.STREET);     /* street address */
     FPRINTF(TXTP, "\t%s\t%s\t%s", RECORD[X].ADDRESS.CITY,
          RECORD[X].ADDRESS.STATE, RECORD[X].ADDRESS.ZIP);/* city state zip */
} /* EXPORT_RECORD */

VOID EXPORT_SELECT(INT N, INT NUM_SELECTED) {
     INT I, C;
     FILE *TXTP;
     CHAR temp[20];

     PRINTF("\nThis will export selected records to a tab delimited file"
            "addrbook.txt\n"
            "\n R) Replace ADDRBOOK.TXT if it exists,"
            "\n A) Append selected records to the end of ADDRBOOK.TXT if it "
            "exists,"
            "\n C) Cancel export and return to main menu."
            "\n\n> ");
     SCANF("%s", temp);
     switch (temp[0]) {
        case 'R':
        case 'r':
                TXTP = FOPEN("ADDRBOOK.TXT", "w");
                break;
        case 'A':
        case 'a':
                TXTP = FOPEN("ADDRBOOK.TXT", "a");
                break;
        default:
                return;
                break;
     }

     
     FOR (I=0, C = 1; I<N; I++)
          IF (SELECTED(I)) {
               EXPORT_RECORD(I, NUM_SELECTED, C++, TXTP);
          }
     FPRINTF(TXTP, "\n");
     FCLOSE(TXTP);
     HIT_ANY_KEY();
} /* EXPORT_SELECT */

VOID SAVE_RECORDS(INT N) {
     INT I;
     FILE *FP;

     SELECT_RECORDS(N, 1);
     IF (N) {
          IF (FP = FOPEN("ADDRBOOK.DAT", "WB")) {
               FOR (I=0; I<N; I++) {
                    IF (SELECTED(I))
                         FWRITE(&RECORD[I], SIZEOF(RECORD[I]), 1, FP);
               } /* FOR I */
               FCLOSE(FP);
          } /* IF FOPEN ADDRBOOK.DAT W */
     } ELSE /* IF N */
          IF (FP = FOPEN("ADDRBOOK.DAT", "RB")) {
               FCLOSE(FP);
               REMOVE("ADDRBOOK.DAT");
          } /* IF FOPEN ADDRBOOK.DAT R */

} /* SAVE_RECORDS */

INT  SELECT_RECORDS(INT N, INT RESET) {
     INT  C, I, SEL;
     STATIC MF_T IMPORTANT; 
     STATIC MF_T NEGATIVE;
     STATIC SORT_T    SORT_BY;
     CHAR START_RANGE[25];
     CHAR END_RANGE[26];
     IF (RESET) {
          IMPORTANT.MASK = 0;
          NEGATIVE.MASK = 0;
          NEGATIVE.FLAG.DELETED = TRUE;
          IMPORTANT.FLAG.DELETED = TRUE; 
          IMPORTANT.FLAG.USED = TRUE;
          SORT_BY = _NONE;
          FOR (I=0; I<N; I++)
               RECORD[I].MF.FLAG.SELECTED = ((IMPORTANT.MASK & (NEGATIVE.MASK
                    ^ RECORD[I].MF.MASK)) == IMPORTANT.MASK);
          FOR (I=0, C=0; I<N; I++) IF (RECORD[I].MF.FLAG.SELECTED) C++;
     } ELSE {
          DO {
               SEL = CENTER_MENU(6, MENU3_TXT, 0);
               SWITCH (SEL) {
                    CASE 1:   CLS();
                              N = SELECT_RECORDS(N, 1);
                              BREAK;
                    CASE 2:   CLS();
                              PRINTF("\nLAST NAME:\n");
                              PRINTF("\tFROM: >  ");
                              INPUT(START_RANGE, ALPHA, 25);
                              PRINTF("\tTO:   >  ");
                              INPUT(END_RANGE, ALPHA, 25);
                              IF (END_RANGE[0] == '\0')
                                   STRCPY(END_RANGE, START_RANGE);
                              IF (STRCMP(START_RANGE, END_RANGE) > 0)
                                   BREAK;
                              SORT_BY = _LAST;
                              BREAK;
                    CASE 3:  CLS();
                              PRINTF("\nFIRST NAME:\n");
                              PRINTF("\tFROM: >  ");
                              INPUT(START_RANGE, ALPHA, 15);
                              PRINTF("\tTO:   >  ");
                              INPUT(END_RANGE, ALPHA, 15);
                              IF (END_RANGE[0] == '\0')
                                   STRCPY(END_RANGE, START_RANGE);
                              IF (STRCMP(START_RANGE, END_RANGE) > 0)
                                   BREAK;
                              SORT_BY = _FIRST;
                              BREAK;
                    CASE 4:   CLS();
                              PRINTF("\nPHONE NUMBER:\n");
                              PRINTF("\tFROM: >  ");
                              INPUT(START_RANGE, ALPHANUMERIC, 20);
                              PRINTF("\tTO:   >  ");
                              INPUT(END_RANGE, ALPHANUMERIC, 20);
                              IF (STRCMP(END_RANGE, NULL) == 0)
                                   STRCPY(END_RANGE, START_RANGE);
                              IF (STRCMP(START_RANGE, END_RANGE) > 0)
                                   BREAK;
                              SORT_BY = _PHONE;
                              BREAK;
                    CASE 5:   CLS();
                              INITIALIZE_MENU();
                              END_RANGE[0] = CENTER_MENU(13, MENU4_TXT, 3)-1;
                              IF ((END_RANGE[0]<0)||(END_RANGE[0]>12))
                                   BREAK;
                              SORT_BY = _DOB;
                              BREAK;
               } /* SWITCH SEL */
          } WHILE (SEL != 6);
     } /* IF ELSE RESET */
     SWITCH (SORT_BY) {
          CASE _LAST:    
          CASE _FIRST:   
          CASE _PHONE:
               strcat(END_RANGE, "Z");
               break;
          CASE _DOB:
               break;
          default:
               break;
     } /* SWITCH */
          SWITCH (SORT_BY) {
               CASE _LAST:    
                    STRCPY(RECORD[MAXRECORDS-2].NAME.LAST, START_RANGE);
                    STRCPY(RECORD[MAXRECORDS-2].NAME.FIRST, NULL);
                    STRCPY(RECORD[MAXRECORDS-2].NAME.MIDDLE, NULL);
                    STRCPY(RECORD[MAXRECORDS-1].NAME.LAST, END_RANGE);
                    STRCPY(RECORD[MAXRECORDS-1].NAME.FIRST, NULL);
                    STRCPY(RECORD[MAXRECORDS-1].NAME.MIDDLE, NULL);
                    BREAK;
               CASE _FIRST:   
                    STRCPY(RECORD[MAXRECORDS-2].NAME.FIRST, START_RANGE);
                    STRCPY(RECORD[MAXRECORDS-2].NAME.LAST, NULL);
                    STRCPY(RECORD[MAXRECORDS-2].NAME.MIDDLE, NULL);
                    STRCPY(RECORD[MAXRECORDS-1].NAME.FIRST, END_RANGE);
                    STRCPY(RECORD[MAXRECORDS-1].NAME.LAST, NULL);
                    STRCPY(RECORD[MAXRECORDS-1].NAME.MIDDLE, NULL);
                    BREAK;
               CASE _PHONE:
                    STRCPY(RECORD[MAXRECORDS-2].PHONE, START_RANGE);
                    STRCPY(RECORD[MAXRECORDS-1].PHONE, END_RANGE);
                    BREAK;
               CASE _DOB:
                    IMPORTANT.FLAG.DOBKNOWN = TRUE;
                    NEGATIVE.FLAG.DOBKNOWN = END_RANGE[0] ? FALSE : TRUE;
                    BREAK;
          } /* SWITCH */
     FOR (I=0; I<N; I++) {
          RECORD[I].MF.FLAG.SELECTED = ((IMPORTANT.MASK &
          (NEGATIVE.MASK^RECORD[I].MF.MASK))==IMPORTANT.MASK);
          IF (SELECTED(I)) SWITCH (SORT_BY) {
               CASE _LAST:    
                    IF (! IN_RANGE(&RECORD[MAXRECORDS-2], &RECORD[I],
                         &RECORD[MAXRECORDS-1], COMPARE_LAST_NAMES))
                              RECORD[I].MF.FLAG.SELECTED = FALSE;
                    BREAK;
               CASE _FIRST:   
                    IF (! IN_RANGE(&RECORD[MAXRECORDS-2], &RECORD[I],
                         &RECORD[MAXRECORDS-1], COMPARE_FIRST_NAMES))
                              RECORD[I].MF.FLAG.SELECTED = FALSE;
                    BREAK;
               CASE _PHONE:
                    IF (! IN_RANGE(&RECORD[MAXRECORDS-2], &RECORD[I],
                         &RECORD[MAXRECORDS-1], COMPARE_PHONE_NUMBERS))
                              RECORD[I].MF.FLAG.SELECTED = FALSE;
                    BREAK;
               CASE _DOB:
                    IF (RECORD[I].DOB.MONTH != END_RANGE[0])
                         RECORD[I].MF.FLAG.SELECTED = FALSE;
                    BREAK;
          } /* SWITCH */
     } /* FOR IF */
     FOR (I=0, C=0; I<N; I++) IF (RECORD[I].MF.FLAG.SELECTED) C++;
     RETURN C;
} /* SELECT_RECORDS */

INT  LOAD_RECORDS(VOID) {
     INT C=0;
     FILE *FP;

     IF (FP = FOPEN("ADDRBOOK.DAT", "RB")) {
          FOR (C=0; (C<MAXRECORDS) && ! FEOF(FP); C++) {
               FREAD(&RECORD[C], SIZEOF(RECORD[0]), 1, FP);
          } /* FOR */
          FCLOSE(FP);
     } /* IF */
     IF (C) RETURN C-1;
     RETURN C;
} /* LOAD_RECORDS */

VOID EXIT_ADDRESS(INT N) {
     CHAR SAVE_CHANGES[2];

     IF (CHANGES) {
          PRINTF("WOULD YOU LIKE TO SAVE YOUR CHANGES ?  ");
          INPUT(SAVE_CHANGES, "YN", 2);
          IF (SAVE_CHANGES[0] == 'Y')
               SAVE_RECORDS(N);
     } /* IF CHANGES */
} /* EXIT_ADDRESS */

INT  SELECTED(INT X) {
     IF (RECORD[X].MF.FLAG.DELETED || ! RECORD[X].MF.FLAG.USED)
          RETURN 0;
     IF (RECORD[X].MF.FLAG.SELECTED == TRUE) RETURN 1;
     RETURN 0;
} /* SELECTED */

INT  MAIN(VOID) {
     INT  NUM; /* NUMBER OF RECORDS READ IN */

     NUM = INITIALIZE();
     MENU1(NUM);
} /* MAIN */

int  SHOW_LIST_OF_NAMES(int n) {
     char temp[80];
     int  i;

     phead = NULL;
     ptail = NULL;

     for (i=0; i<n; i++) {
          if (phead) {
               sprintf(temp, "%3d) %s %s %s\n", i+1, RECORD[i].NAME.FIRST,
                    RECORD[i].NAME.MIDDLE, RECORD[i].NAME.LAST);
               ptail->next = (struct tag *)malloc(sizeof(struct tag));
               if (ptail->next == NULL) {
                    fputs("\nOut of memory!\n", stderr);
                    exit(2);
               }
               ptail->next->prev = ptail;
               ptail = ptail->next;
               strcpy(ptail->info, temp);
               ptail->next = NULL;
          } else {
               phead = (struct tag *)malloc(sizeof(struct tag));
               sprintf(phead->info, "%3d) %s %s %s\n", i+1,
                    RECORD[i].NAME.FIRST, RECORD[i].NAME.MIDDLE, 
                    RECORD[i].NAME.LAST);
               ptail = phead;
               ptail->next = NULL;
               ptail->prev = NULL;
          }
     } /* enter a line into the list */
     Show_List(phead, "INDEX OF NAMES");
     return 0;
} /* SHOW_LIST_OF_NAMES */

int  PRINT_LIST_OF_NAMES(int n) {
     char temp[80];
     int  i;

     phead = NULL;
     ptail = NULL;

     for (i=0; i<n; i++) {
          if (phead) {
               sprintf(temp, "%3d) %s %s %s\n", i+1, RECORD[i].NAME.FIRST,
                    RECORD[i].NAME.MIDDLE, RECORD[i].NAME.LAST);
               ptail->next = (struct tag *)malloc(sizeof(struct tag));
               if (ptail->next == NULL) {
                    fputs("\nOut of memory!\n", stderr);
                    exit(2);
               }
               ptail->next->prev = ptail;
               ptail = ptail->next;
               strcpy(ptail->info, temp);
               ptail->next = NULL;
          } else {
               phead = (struct tag *)malloc(sizeof(struct tag));
               sprintf(phead->info, "%3d) %s %s %s\n", i+1,
                    RECORD[i].NAME.FIRST, RECORD[i].NAME.MIDDLE, 
                    RECORD[i].NAME.LAST);
               ptail = phead;
               ptail->next = NULL;
               ptail->prev = NULL;
          }
     } /* enter a line into the list */
     Print_List(phead, "INDEX OF NAMES");
     return 0;
} /* PRINT_LIST_OF_NAMES */
