#ifndef BASIC_H
#define BASIC_H

#include <BIOS.H>

void CLS(void)
{
     clrscrn2( 0X17 );
     curson();
     return;
}

void COLOR(int FOREGROUND, BACKGROUND, BORDER)
{
     FOREGROUND %= 16;
     BACKGROUND %= 16;
     BORDER     %= 16;

     clrscrn2(BACKGROUND<<4|FOREGROUND);
     setcolor(BORDER, 0);
     return;
}

int  CSRLIN(void)
{
     return cursrow()+1;
}

int  INKEY(void)
{
     return (bioskey(1) ? bioskey(0) : 0);
}

int  LOCATE(int ROW, int COLUMN)
{
     if ((ROW < 1) || (ROW > 25) || (COLUMN < 1) || (COLUMN > 80))
          return 1;
     poscurs( ROW-1, COLUMN-1);
     return 0;
}

int POS(void)
{
     return curscol()+1;
}

int WIDTH(int COLUMNS)
{
     if (getvmode() == 0X07) return 0;
     if ((COLUMNS != 80) && (COLUMNS != 40))
          return 1;
     setvmode(COLUMNS == 40 ? 1 : 3);
     return 0;
}
#endif
