#ifndef DATE_H
#define DATE_H

#include <DOS.H>
#include <STDIO.H>
#include <STDLIB.H>
#include <STRING.H>
#include "INPUT.H"

#define   DATECHARS      "X0123456789 ,./-"

typedef   struct {
               int  MONTH;
               int  DAY;
               int  YEAR;
} DATE_T;

void GET_DATE(DATE_T *DA) {
     char DATE_STR[80];
     char *NUMSTR;
     int  N, M, D, Y;
     int  NEED_DATE = 1;
     struct date DATEBUF;
     int  UNKNOWN = 0;
     union REGS R;

     R.x.ax = 0X0C00;
     intdos(&R, &R);
     while (NEED_DATE) {
        NEED_DATE = 0;
        INPUT(DATE_STR, "X1234567890 ,./-", 25);
        NUMSTR = strtok(DATE_STR, " ,./-");
        if (NUMSTR == NULL) {
                getdate(& DATEBUF);
                M = DATEBUF.da_mon;
                D = DATEBUF.da_day;
                Y = DATEBUF.da_year % 100;
                break;
        } /* GET DATE FROM DOS if NO INFO WAS INPUT */
        N = atoi(NUMSTR);
        if ((N<1)||(N>12)) {
                printf("\NMONTH OUT OF RANGE!\NENTER DATE> ");
                NEED_DATE = 1; continue;
        } /* if MONTH OUT OF RANGE */
        M = N;
        NUMSTR = strtok(NULL, " ,./-");
        if (NUMSTR == NULL) {
                printf("\N? ");
                NEED_DATE = 1; continue;
        } /* INVALID DATE STRING */
        N = atoi(NUMSTR);
        if ((N<0)||(N>31)) {
                printf("\NDAY OF MONTH OUT OF RANGE!\NENTER DATE> ");
                NEED_DATE = 1; continue;
        } /* if DAY OF MONTH OBVIOUSLY BAD */
        if (N==31)
                switch (M) {
                        case  2: if (N<=29)
                                        break;
                        case  4:
                        case  6:
                        case  9:
                        case 11: printf("\NDAY OF MONTH OUT OF RANGE!"); 
                                 printf("\NENTER DATE> ");
                                 NEED_DATE = 1; continue;
                                 break;
                } /* CLOSING BRACES FOR switch, ALSO ENDS if N=31 */
        D = N;
        NUMSTR = strtok(NULL, " ,./-");
        if (NUMSTR == NULL) {
                printf("\N? ");
                NEED_DATE = 1; continue;
        } /* INVALID DATE STRING */
        if ((NUMSTR[0]=='X')&&(NUMSTR[1]=='X')) UNKNOWN = 1;
        N = atoi(NUMSTR);
        if ((N<0)||((N>99)&&(N<1900))||(N>2080)) {
                printf("\NYEAR MUST BE BETWEEN 1900 AND 2079!");
                printf("\NENTER DATE> ");
                NEED_DATE = 1; continue;
        } /* INVALID YEAR */
        if ((M!=2)||(D<29)) {
                if (N<100)
                        Y = N;
                else if (N<2000)
                        Y = N - 1900;
                else
                        Y = N - 2000;
        } else { /* if IT'S FEBRUARY 29 */
                if (N<80)
                        Y = 2000 + N;
                else if (N<100)
                        Y = 1900 + N;
                if ((Y%4)||(((Y%100)==0)&&(Y%400))) {
                        printf("\NFEBRUARY ONLY HAS 28 DAYS THIS YEAR!");
                        printf("\NENTER DATE> ");
                        NEED_DATE = 1; continue;
                } /* NOT A LEAP YEAR */
                Y = Y - 1900;
                if (Y>100)
                        Y = Y - 100;
        } /* if else LEAP YEAR OR NOT if NECCESSARY */
     } /* while */;
     DA->MONTH = M;
     DA->DAY   = D;
     DA->YEAR  = Y;
     if (UNKNOWN) DA->YEAR = -1;
} /* GET_DATE */

void DISPLAY_DATE(DATE_T DA) {
     if (DA.YEAR > -1)
          printf("%d/%02d/%02d", DA.MONTH, DA.DAY, DA.YEAR);
     else
          printf("%d/%02d/XX", DA.MONTH, DA.DAY);
} /* DISPLAY_DATE */

void PRINT_DATE(DATE_T DA) {
     if (DA.YEAR > -1)
          fprintf(stdprn, "%d/%02d/%02d", DA.MONTH, DA.DAY, DA.YEAR);
     else
          fprintf(stdprn, "%d/%02d/XX", DA.MONTH, DA.DAY);
} /* PRINT_DATE */

void FPRINT_DATE(FILE* fp, DATE_T DA) {
     if (DA.YEAR > -1)
          fprintf(fp, "%d/%02d/%02d", DA.MONTH, DA.DAY, DA.YEAR);
     else
          fprintf(fp, "%d/%02d/XX", DA.MONTH, DA.DAY);
} /* FPRINT_DATE */

#ENDIF
