#include <stdio.h>
#include <dos.h>
#include <process.h>
#include <string.h>
#include <bios.h>
#include <graphics.h>

char table[] = { 0, 4, 2, 6, 1, 5, 3, 7, 8, 12, 10, 14, 9, 13, 11, 15 };

set(int y, x, b) {
    int l, h;
    union REGS regs;

    h = (b & 0xf0)>>4;
    l = (b & 0x0f);

    regs.h.ah = 0x0c;           /* write graphics pixel */
    regs.h.al = table[h];       /* set pixel value */
    regs.h.bh = 0;              /* set video page */
    regs.x.cx = x;              /* set column */
    regs.x.dx = y;              /* set row */
    int86(0x10, &regs, &regs);  /* do it */
    regs.h.al = table[l];       /* set pixel value */
    regs.x.cx++;                /* increment column */
    int86(0x10, &regs, &regs);  /* do it */

}

int showjwbbmp(void) {
    char i, solid = PENCOLOR;
    long length, offset, width, height;
    int bitsperpixel, R=0, C=0, r, c;
    FILE *fp;

    fp = fopen("jwb.bmp", "rb");
    if (fp==NULL) return 1;
    fseek(fp, 2l, SEEK_SET);
    fread(&length, sizeof(long), 1, fp);
    fseek(fp, 10l, SEEK_SET);
    fread(&offset, sizeof(long), 1, fp);
    fseek(fp, 18l, SEEK_SET);
    fread(&width, sizeof(long), 1, fp);
    fseek(fp, 22l, SEEK_SET);
    fread(&height, sizeof(long), 1, fp);
    fseek(fp, 28l, SEEK_SET);
    fread(&bitsperpixel, sizeof(int), 1, fp);
    fseek(fp, offset, SEEK_SET);
    width = width&7?(width+8) & 0xfffffff8:width;

    setvmode(13);
    R = 100-height/2;
    C = 160-width/2;
    /* if (width & 1) width++;    */
    for (r=0; r<height; r++)
        for (c=0; c<width; c+=2) {
            fread(&i, 1, 1, fp);
            set(R+height-r, C+c, i);
    }   
    getch();
    setvmode(3);
}

int main() {
    FILE    *fp;
    int     done;
    char    c;
    union REGS regs;
   
    if (fp=fopen("judgewar.inf", "r")) {
        c = fgetc(fp);
        fclose(fp);
    } else {
        clrscrn();
        fputs("What type of moniter are you using?\n\n", stdout);
        fputs("\t1. Monochrome\n", stdout);
        fputs("\t2. CGA\n", stdout);
        fputs("\t3. EGA\n", stdout);
        fputs("\t4. VGA\n", stdout);
        fputs("> ", stdout);
        do {
            c = getch();
            if (c<'1') done = 0;
            else if (c>'4') done = 0;
            else done = 1;
        } while (! done);
        c -= '1';
        fp = fopen("judgewar.inf", "w");
        fputc(c, fp);
        fclose(fp);
        regs.x.ax = 0x4301; /* change attribute */
        regs.x.cx = 7; /* system hidden read only */
        regs.x.dx = "judgewar.inf";
        intdos(&regs, &regs);
    } /* if - else */
    if (c>1)
        showjwbbmp();
    execl("addrbook.pgm", NULL);
}
