#ifndef INPUT_H
#define INPUT_H

#include <CONIO.H>
#include <BIOS.H>
#include <DOS.H>
#include <STDIO.H>
#include "tmouse.h"

int  INPUT(char *STRNG, char *ACCEPT, int MAX_LEN) {
     int C, N = 0, I = 0, CUR_ROW, i;

     for (i=1; i<MAX_LEN; i++) putchar('_');
     for (i=1; i<MAX_LEN; i++) putchar('\b');

     CUR_ROW = cursrow();
     do {
          if (CUR_ROW != cursrow()) {
               STRNG[N] = '\0';
               return N;
          } /* if */
          C = getch();
          C = toupper(C);

          switch(C) {
               case '\x1B':   /* ESCAPE */
                    for (I = 0; I<N; I++) putchar('\b');
                    for (I = 0; I<N; I++) putchar('_');
                    for (I = 0; I<N; I++) putchar('\b');
                    strcpy( STRNG, NULL);
                    N = 0;
                    break;
               case '\b':     /* BACKSPACE */
                    if (N<=0) break;
                    putchar('\b');
                    putchar('_');
                    putchar('\b');
                    N--;
                    break;
               case '\r':     /* return */
                    putchar('\n');
                    STRNG[N] = '\0';
                    return N;
                    break;
               case '\t':     /* TAB */
                    if (ACCEPTED(C, ACCEPT)) {
                         if ((N+8)>=MAX_LEN)
                              putchar('\a');
                         else
                              for (I=0; I<8; I++) {
                                   putchar(' ');
                                   STRNG[N++] = ' ';
                              } /* for */
                    } else
                         putchar('\a');
                    break;
               DEFAULT:
                    if (ACCEPTED(C, ACCEPT)) {
                         STRNG[N++] = C;
                         putchar(C);
                    } else {
                         putchar('\a');
                         if (C == '\0')
                              getch();
                    } /* if else */
                    break;
          } /* switch */
     } while (N < MAX_LEN-1);
     STRNG[MAX_LEN - 1] = '\0';
     putchar('\n');
     if (MAX_LEN > 2) putchar('\a');
     return MAX_LEN;
} /* INPUT */

int  ACCEPTED(int C, char *STRNG) {
     for (; *STRNG; STRNG++) if (C == *STRNG) return 1;
     return 0;
} /* ACCEPTED */

int  HIT_ANY_KEY(void) {
     union REGS R;
     int C, d, e;

     R.x.ax = 0X0C00;
     intdos(&R, &R);
     curson();
     putchar('\n');
     poscurs(cursrow(), 33); 
     printf("<HIT ANY KEY!>");
     while ((C = bioskey(1)) == 0)
        if (CLICK_AT()) break;
     d = C & 255;
     e = C>>8;
     if (MOUSE_MOVED==1) return 0;
     if (MOUSE_MOVED==2) return 1;
     if (d) switch (d) {
        case 0x1b:/* esc */
            return 1;
        default:
            return 0;
     } else switch (e) {
        case 0x47:/* home */
            return 2;
        case 0x48:/* up */
        case 0x49:/* pgup */
        case 0x4b:/* left */
            return 3;
        case 0x4f:/* end */
            return 4;
        default:
            return 0;
     } /* switch */
} /* HIT_ANY_KEY */

#endif

