#include <bios.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "screen.h"

struct tag {
	char           info[80];
	struct tag     *next;
	struct tag     *prev;
} *phead, *ptail;

void Help(void);
char *Fgets(char *buf, int n, FILE *inputfile);
void Show_List(struct tag *plist, char *filename);
int  show_file(char *filename);

int  show_file(char *filename) {
	FILE *fp;
	char temp[80];

	phead = NULL;
	ptail = NULL;

	fp = fopen(filename, "r");
	if (fp == NULL) {
		fputs("\nCannot open file!\n", stderr);
		return(1);
	}
	while (! feof(fp)) {
		if (phead) {
			if (Fgets(temp, 75, fp)==NULL) break;
			ptail->next = (struct tag *)malloc(sizeof(struct tag));
			if (ptail->next == NULL) {
				fputs("\nOut of memory!\n", stderr);
				exit(2);
			}
			ptail->next->prev = ptail;
			ptail = ptail->next;
			strcpy(ptail->info, temp);
			ptail->next = NULL;
		} else {
			phead = (struct tag *)malloc(sizeof(struct tag));
			Fgets(phead->info, 75, fp);
			ptail = phead;
			ptail->next = NULL;
			ptail->prev = NULL;
		}
	} /* enter a line into the list */
	Show_List(phead, filename);
	return 0;
} /* show_file */

int  print_file(char *filename) {
	FILE *fp;
	char temp[80];

	phead = NULL;
	ptail = NULL;

	fp = fopen(filename, "r");
	if (fp == NULL) {
		fputs("\nCannot open file!\n", stderr);
		return(1);
	}
	while (! feof(fp)) {
		if (phead) {
			if (Fgets(temp, 75, fp)==NULL) break;
			ptail->next = (struct tag *)malloc(sizeof(struct tag));
			if (ptail->next == NULL) {
				fputs("\nOut of memory!\n", stderr);
				exit(2);
			}
			ptail->next->prev = ptail;
			ptail = ptail->next;
			strcpy(ptail->info, temp);
			ptail->next = NULL;
		} else {
			phead = (struct tag *)malloc(sizeof(struct tag));
			Fgets(phead->info, 75, fp);
			ptail = phead;
			ptail->next = NULL;
			ptail->prev = NULL;
		}
	} /* enter a line into the list */
	Print_List(phead, filename);
	return 0;
} /* print_file */

char *Fgets(char *buf, int n, FILE *inputfile) {
	int i, endtab;
	char c;

	if (feof(inputfile)) return NULL;

	for (i=0; (i<n) && ! feof(inputfile); i++) {
		c = fgetc(inputfile);
		if (feof(inputfile)) break;
		if ((c == '\t') && (i<n-4)) {
			for (endtab = i+3; i<endtab; i++)
				buf[i] = ' ';
			c = ' ';
		}
		if (c == '\n') {
			buf[i++] = c;
			break;
		}
		buf[i] = c;
	}
	buf[i] = '\0';
	return buf;
} /* Fgets */

#define testout stdprn

void Print_List(struct tag *plist, char *filename) {
	 int l=1;
	 int p=1;
	 int np=0;

	 while (plist) {
		 fprintf(testout, "\n\n       %-47s  page %d", filename, p);
		 fprintf(testout,
			"\n       ---------------------------------------------");
		 fprintf(testout, "\n\n");
		 do {
			 fprintf(testout, "        %s", plist->info);
			 l++;
			 if (strchr(plist->info, '\f')!=NULL) np=1;
			 plist = plist->next;
			 if (np) {
				np = 0;
				break;
			 }
		 } while (plist && (l<50));
		 if (!(plist && (l<50)))
			fputc('\f', testout);
		 l = 1;
		 p++;
	 }
} /* Print_List */

void Show_List(struct tag *plist, char *filename) {
	 typedef struct {
			   char BACKGROUND;
			   char CHARACTER_A;
			   char HIGHLIGHT_A;
			   char TYPE_M_CURS;
			   char COLOR_M_CURS;
	 } VIDEO_T;
	int count, i;
	int done = 0, top = 1, bottom = 20;
	int extended = 0;
	char c;
	struct tag *pfirst;
	struct tag *plast;
	struct tag *ptop;
	struct tag *pbottom;
	 VIDEO_T   V = { 0X07, 0X70, 0X0F, 0X00, 0X7F };
	 char BACKG, TEXTC, HIGHC;
	 FILE *FPCOLOR;

	 FPCOLOR = fopen("COLOR.DAT", "R");
	 if (FPCOLOR) {
		  fread(&V, sizeof(VIDEO_T), 1, FPCOLOR);
		  fclose(FPCOLOR);
	 }
	 BACKG = V.BACKGROUND;
	 TEXTC = V.CHARACTER_A;
	 HIGHC = V.HIGHLIGHT_A;

	clrscrn2(BACKG*16);
	pfirst = plist;
	for (count = 1; plist->next; count++)
		plist = plist->next;
	if (count<20) bottom = count;
	plast = plist;
	plist = pfirst;
	clearwindow(2, 6, 23, 74, HIGHC);
	clearwindow(3, 7, 22, 73, TEXTC);
	poscurs(2,7);
	printf("%s", filename);
	poscurs(2,53);
	printf(" %d - %d / %d     ", top, bottom, count);
	poscurs(23,9);
	printf("HOME       PGUP       %c", 0x18 /* UP ARROW */);
	printf("       ESC       %c       PGDN       END", 0x19 /* DOWN ARROW */);
	cursoff();
	for (i = 0; i<20; i++) {
		windowscrollup(3, 8, 22, 73, TEXTC, 1);
		fputs(plist->info, stderr);
		if (plist->next)
			plist = plist->next;
		else
			break;
	} /* for */

	ptop      = pfirst;
	pbottom   = plist->prev;
	if (count >20) {
	do {
		done = 0;
		extended = 0;
		c = getch();
		if (c == 0) {
			extended = 1;
			c = getch();
		}
		if (extended)
			switch (c) {
				case 0x47: /* HOME */
					if (ptop == pfirst)
						putchar('\a');
					while (ptop != pfirst) {
						top--;
						bottom--;
						ptop = ptop->prev;
						pbottom = pbottom->prev;
						windowscrolldown(3, 8, 22, 73, TEXTC, 1);
						fputs(ptop->info, stderr);
					}
					break;
				case 0x48: /* UP ARROW */
					if (ptop == pfirst) {
						putchar('\a');
						break;
					}
					top--;
					bottom--;
					ptop = ptop->prev;
					pbottom = pbottom->prev;
					windowscrolldown(3, 8, 22, 73, TEXTC, 1);
					fputs(ptop->info, stderr);
					break;
				case 0x49: /* PAGE UP */
					if (ptop == pfirst) {
						putchar('\a');
						break;
					}
					plist = ptop->next;
					while ((pbottom != plist)&&(ptop != pfirst)) {
						top--;
						bottom--;
						ptop = ptop->prev;
						pbottom = pbottom->prev;
						windowscrolldown(3, 8, 22, 73, TEXTC, 1);
						fputs(ptop->info, stderr);
					} /* while */
					break;
				case 0x4f: /* END */
					if (pbottom == plast)
						putchar('\a');
					while (pbottom != plast) {
						top++;
						bottom++;
						if (bottom>count) {
							bottom--;
							top--;
							putch('\a');
							break;
						}
						ptop = ptop->next;
						pbottom = pbottom->next;
						windowscrollup(3, 8, 22, 73, TEXTC, 1);
						fputs(pbottom->info, stderr);
					}
					break;
				case 0x50: /* DOWN ARROW */
					if (pbottom == plast) {
						putchar('\a');
						break;
					}
					top++;
					bottom++;
					if (bottom>count) {
							bottom--;
							top--;
							putch('\a');
							break;
					}
					ptop = ptop->next;
					pbottom = pbottom->next;
					windowscrollup(3, 8, 22, 73, TEXTC, 1);
					fputs(pbottom->info, stderr);
					break;
				case 0x51: /* PAGE DOWN */
					if (pbottom == plast) {
						putchar('\a');
						break;
					}
					plist = pbottom->prev;
					while ((ptop != plist)&&(pbottom != plast)) {
						top++;
						bottom++;
						if (bottom>count) {
							bottom--;
							top--;
							putch('\a');
							break;
						}
						ptop = ptop->next;
						pbottom = pbottom->next;
						windowscrollup(3, 8, 22, 73, TEXTC, 1);
						fputs(pbottom->info, stderr);
					} /* while */
					break;
				default  :
					putchar('\a');
					break;
			} /* switch */
		else
			switch (c) {
				case 0x1b: /* ESC */
					done = 1;
					plist = phead;
					while (plist) {
						phead = phead->next;
						free(plist);
						plist = phead;
					}
					ptail = NULL;
					break;
				default  :
					putchar('\a');
					break;
			} /* switch */
		poscurs(2,7);
		printf("%s", filename);
		poscurs(2,53);
		printf(" %d - %d / %d     ", top, bottom, count);
	} while (! done);
	} else {
	do {
		done = 0;
		extended = 0;
		c = getch();
		if (c == 0) {
			extended = 1;
			c = getch();
		}
			switch (c) {
				case 0x1b: /* ESC */
					done = 1;
					plist = phead;
					while (plist) {
						phead = phead->next;
						free(plist);
						plist = phead;
					}
					ptail = NULL;
					break;
				default  :
					putchar('\a');
					break;
			} /* switch */
		poscurs(2,7);
		printf("%s", filename);
		poscurs(2,53);
		printf(" %d - %d / %d     ", top, bottom, count);
	} while (! done);
	}
	curson();
	clrscrn();
} /* Show_List */
