#IFNDEF MENU_H
#DEFINE MENU_H

#INCLUDE <BIOS.H>
#INCLUDE <CONIO.H>
#INCLUDE <CTYPE.H>
#INCLUDE <DOS.H>
#INCLUDE <MALLOC.H>
#INCLUDE <STDIO.H>
#INCLUDE <STRING.H>
#INCLUDE "BASIC.H"
#INCLUDE "TMOUSE.H"

#DEFINE  UP    0X4800
#DEFINE  DOWN  0X5000
#DEFINE  HOME  0X4700
#DEFINE  END   0X4F00
#DEFINE  PGUP  0X4900
#DEFINE  PGDN  0X5100
#DEFINE  ESC   0X001B
#DEFINE  ENTER 0X000D
#DEFINE  MAXWIDTH 60

CHAR UL[] = { 218, 213, 214, 201, ',' };
CHAR UR[] = { 191, 184, 183, 187, '.' };
CHAR LL[] = { 192, 212, 211, 200, '`' };
CHAR LR[] = { 217, 190, 189, 188, '\'' };
CHAR HL[] = { 195, 198, 199, 204, '|' };
CHAR HR[] = { 180, 181, 182, 185, '|' };
CHAR VU[] = { 194, 209, 210, 203, '.' };
CHAR VL[] = { 193, 207, 208, 202, '^' };
CHAR VE[] = { 179, 179, 186, 186, '|' };
CHAR CR[] = { 197, 216, 215, 206, '+' };
CHAR HO[5][79];

INT W;
INT V_OFF = 2;
INT H_OFF = 0;
INT M = 1;
CHAR BACKG, TEXTC, HIGHC;

INT  QUIT(VOID) {
     COLOR(15, 0, 0);
     CURSON();

     RETURN 0;
} /* QUIT */

VOID INITIALIZE_MENU(VOID) {
     INT I;

     INITIALIZE_MOUSE();
     CTRLBRK(QUIT);
     FOR (I=0; I<78; I++) {
          HO[0][I] = HO[2][I] = 196;
          HO[1][I] = HO[3][I] = 205;
          HO[4][I] = '-';
     } /* FOR */
     V_OFF = 2;
     H_OFF = 0;
} /* INITIALIZE_MENU */ 

INT  CENTER_MENU(INT NUMBER, CHAR **TEXT, INT STYLE) {
     INT W, X, Y, I;

     IF (NUMBER<2) RETURN 0;
     IF ((M != 1) && (M != 2)) RETURN 0;
     Y = 9 - NUMBER/2;
     FOR (I = 0, W= 0; I<(NUMBER+1); I++)
          W = (STRLEN(TEXT[I])>W) ? STRLEN(TEXT[I]) : W;
     X = (40/M) - W/2 - 1;

     RETURN(MENU(NUMBER, TEXT, STYLE, Y, X));
} /* CENTER_MENU */

INT  MENU(INT N, CHAR **TEXT, INT S, INT ROW, INT COL) {
     TYPEDEF STRUCT {
               CHAR BACKGROUND;
               CHAR CHARACTER_A;
               CHAR HIGHLIGHT_A;
               CHAR TYPE_M_CURS;
               CHAR COLOR_M_CURS;
     } VIDEO_T;

     VIDEO_T   V = { 0X07, 0X70, 0X0F, 0X00, 0X7F };
     INT I, SEL;
     CHAR TEMPOR[256];
     FILE *FPCOLOR;

     IF ((M != 1) && (M != 2)) RETURN 0;
     FPCOLOR = FOPEN("COLOR.DAT", "R");
     IF (FPCOLOR) {
          FREAD(&V, SIZEOF(VIDEO_T), 1, FPCOLOR);
          FCLOSE(FPCOLOR);
     }
     BACKG = V.BACKGROUND;
     TEXTC = V.CHARACTER_A;
     HIGHC = V.HIGHLIGHT_A;
     DEFINE_MOUSE(V.TYPE_M_CURS, V.COLOR_M_CURS);


     IF (N<2) RETURN 0;
     SETCBRK(0);
     WIDTH(80/M);
     CURSOFF();
     V_OFF = ROW;
     FOR (I=0, W=0; I<(N+1); I++)
          W = (STRLEN(TEXT[I])>W) ? STRLEN(TEXT[I]) : W;
     IF (STRLEN(TEXT[0])<(W-1)) {
          SPRINTF(TEMPOR, "%*c%s", (W - STRLEN(TEXT[0]))/2, ' ', TEXT[0]);
     } ELSE STRCPY(TEMPOR, TEXT[0]);
     H_OFF = COL;
     COLOR(TEXTC & 0X0F, BACKG, BACKG);
     FOR (I=0; I<V_OFF; I++)
          PUTCHAR('\N');
     BIOS_WINDOW(V_OFF+1, H_OFF+1, V_OFF + N + 4, H_OFF + W + 5, 0X00);
     BIOS_WINDOW(V_OFF, H_OFF, V_OFF + N + 3, H_OFF + W + 4, TEXTC);
     PRINTF("%*c%c%-.*s%c\N", H_OFF, ' ',UL[S], W+2, HO[S], UR[S]);
     PRINTF("%*c%c %-*s %c\N", H_OFF, ' ', VE[S], W, TEMPOR, VE[S]);
     PRINTF("%*c%c%-.*s%c\N", H_OFF, ' ', HL[S], W+2, HO[S], HR[S]);
     FOR (I=0; I<N; I++)
          PRINTF("%*c%c %-*s %c\N", H_OFF, ' ', VE[S], W, TEXT[I+1], VE[S]);
     PRINTF("%*c%c%-.*s%c\N", H_OFF, ' ', LL[S], W+2, HO[S], LR[S]);
     LIMIT_MOUSE(V_OFF + 1, H_OFF * M + 2, N+1, W*M - 1);
     MOUSE_ON();
     SEL = _MENU(N, TEXT, S, TEXTC, HIGHC);
     MOUSE_OFF();
     RESET_MOUSE();
     SETCBRK(1);
     CURSON();
     WIDTH(80);
     COLOR(15, 1, 1);
     HIGHLIGHT(99, NULL, 0, 0);

     RETURN SEL;
} /* MENU */

INT  _MENU(INT N, CHAR **TEXT, INT S, CHAR TEXTC, CHAR HIGHC) {
     STATIC INT SEL = 1;
     INT C;
     UNION REGS R;

     R_X_AX = 0X0C00;
     INTDOS(&R, &R);
     IF (SEL > N) SEL = 1;
     FOR (;;) {
          HIGHLIGHT(SEL, TEXT, TEXTC, HIGHC);
          WHILE ((! BIOSKEY(1)) && (! CLICK_AT())) ;
          IF (MOUSE_MOVED==1) C = MOUSE_Y + '@' - 2 - V_OFF;
          else if (MOUSE_MOVED==2) C = ESC;
          IF (! MOUSE_MOVED) {
               C = GETCH();
               C = TOUPPER(C);
               IF (C == 0)
                    C = GETCH() * 256;
          }

          SWITCH (C) {
               CASE UP:       IF (SEL == 1) SEL = N;
                                   ELSE SEL--;
                              BREAK;
               CASE DOWN:     IF (SEL == N) SEL = 1;
                                   ELSE SEL++;
                              BREAK;
               CASE PGUP:
               CASE HOME:     SEL = 1;
                              BREAK;
               CASE PGDN:
               CASE END:      SEL = N;
                              BREAK;
               CASE ESC:      RETURN 0;
                              BREAK;
               CASE ENTER:
               CASE ' ':      RETURN SEL;
                              BREAK;
               DEFAULT:       IF (ISDIGIT(C))
                                   IF ((C-'0') <= N) {
                                        SEL = C-'0';
                                        RETURN SEL;
                                   } ELSE PUTCHAR('\a');
                              ELSE IF (ISALPHA(C))
                                   IF ((C-'@') <= N) {
                                        SEL = C-'@';
                                        RETURN SEL;
                                   } ELSE PUTCHAR('\a');
                              ELSE IF (C == '@') {
                                   SEL = 1;
                                   RETURN 0;
                              } ELSE IF (C == '?') RETURN -1;
                              ELSE PUTCHAR('\a');
          } /* SWITCH */
     } /* FOR */
} /* _MENU */

VOID HIGHLIGHT(INT N, CHAR **STRING, CHAR NORM, CHAR HIGH) {
     STATIC OLD = 1;

     IF (N == 99) {
          OLD = 1;
          RETURN;
     } /* IF */
     MOUSE_OFF();
     LOCATE(V_OFF + 3 + OLD, H_OFF + 3);
     WRITECHS(' ', NORM, W);
     LOCATE(V_OFF + 3 + OLD, H_OFF + 3);
     PRINTF("%-s", STRING[OLD]);
     LOCATE(V_OFF + 3 + N, H_OFF + 3);
     WRITECHS(' ', HIGH, W);
     LOCATE(V_OFF + 3 + N, H_OFF + 3);
     PRINTF("%-s", STRING[N]);
     OLD = N;
     MOUSE_ON();
} /* HIGHLIGHT */

VOID BIOS_WINDOW(INT TOP, LEFT, BOTTOM, RIGHT, V_A) {
        UNION REGS R;

        R.x.ax = 0x0600;
        R.h.ch = TOP;
        R.h.cl = LEFT;
        R.h.dh = BOTTOM;
        R.h.dl = RIGHT;
        R.h.bl = 0;
        R.h.bh = V_A;
        INT86(0x10, &R, &R);
}

VOID BOX(INT T, L, B, R, A, S) {
     INT V_OFF, H_OFF, W, I;
     CHAR TEMPOR[80];
     
     IF ((T<0)||(L<0)||(B<T)||(R<L)||(R>79)||(B>24))
          RETURN;
     CURSOFF();
     FOR (I=0; I<78; I++) {
          HO[0][I] = HO[2][I] = 196;
          HO[1][I] = HO[3][I] = 205;
          HO[4][I] = '-';
     } /* FOR */
     V_OFF = T-1;
     H_OFF = L-1;
     W = R - L;
     STRCPY(TEMPOR, " ");
     FOR (;STRLEN(TEMPOR)<W;)
          STRCAT(TEMPOR, " ");
     COLOR(TEXTC & 0X0F, BACKG, BACKG);
     BIOS_WINDOW(T, L, B+1, R+3, 0X00);
     BIOS_WINDOW(T-1, L-1, B, R+2, A);
     FOR (I=0; I<V_OFF; I++)
          PUTCHAR('\N');
     PRINTF("%*c%c%-.*s%c\N", H_OFF, ' ',UL[S], W+2, HO[S], UR[S]);
     FOR (I=0; I<(B-T); I++)
          PRINTF("%*c%c %-*s %c\N", H_OFF, ' ', VE[S], W, TEMPOR, VE[S]);
     PRINTF("%*c%c%-.*s%c\N", H_OFF, ' ', LL[S], W+2, HO[S], LR[S]);
} /* BOX */

#ENDIF
