#ifndef TMOUSE_H
#define TMOUSE_H

#include  <dos.h>

#define   MOUSECALL int86(0x33, &r, &r)
#define   RESET_MOUSE() INITIALIZE_MOUSE()
union REGS r;

int       MOUSE = 0, MOUSE_MOVED = 0;
int       MOUSE_X, MOUSE_Y;

void      INITIALIZE_MOUSE(void) {
          int version;

          r.x.ax = 0x3001;
          int86(0x21, &r, &r);
          version = r.h.al << 8 | r.h.ah;
          if (version < 0x0314) {
               MOUSE = 0;
               return;
          }
          r.x.ax = 0x0000;
          MOUSECALL;
          MOUSE = r.x.ax;
}

void      DEFINE_MOUSE(char character, char color) {
          if (MOUSE)
               if (character) {
                    r.x.ax = 0x000a;
                    r.x.bx = 0x0000;
                    r.h.ch = 0x00;
                    r.h.cl = 0x00;
                    r.h.dh = color;
                    r.h.dl = character;
                    MOUSECALL;
               } else COLOR_MOUSE((char) color);
}

void      COLOR_MOUSE(char color) {
          if (MOUSE) {
               r.x.ax = 0x000a;
               r.x.bx = 0x0000;
               r.x.cx = 0x07ff;
               r.h.dl = 0x00;
               r.h.dh = color;
               MOUSECALL;
          }
}

void      LIMIT_MOUSE(int top, int left, int length, int width) {
          if (! MOUSE) return;

          r.x.ax = 0x0007;
          r.x.cx = left << 3;
          r.x.dx = (left + width) << 3;
          MOUSECALL;
          r.x.ax = 0x0008;
          r.x.cx = top << 3;
          r.x.dx = (top + length) << 3;
          MOUSECALL;
}

void      MOUSE_ON(void) {
          int i;

          if (MOUSE)
               for (i=0; i<20; i++) {
                    r.x.ax = 0x0001;
                    MOUSECALL;
               }
}

void      MOUSE_OFF(void) {
          if (MOUSE) {
               r.x.ax = 0x0002;
               MOUSECALL;
          }
}

int       CLICK_AT(void) {
          int s;

          if (! MOUSE) return 0;
          MOUSE_MOVED = 0;
          r.x.ax = 0x0003;
          MOUSECALL;
          if (r.x.bx == 0) return 0;  /* no button */
          if (r.x.bx & 0x02) {
               MOUSE_MOVED = 2;
               return 0; 
          } /* right button */
/* else left button */
          r.x.ax = 0x0006;
          r.x.bx = 0x0000;
          MOUSECALL;
          while (r.x.ax) {
               r.x.ax = 0x0006;
               r.x.bx = 0x0000;
               MOUSECALL;
          }
          MOUSE_MOVED = 1;
          MOUSE_X = r.x.cx >> 3;
          MOUSE_Y = r.x.dx >> 3;

          return r.x.bx;
}

#endif
